class OAuthsController < ApplicationController
  before_action :set_user

  def index
    @models = @user.o_auths
    @count = @models.count
  end

  def destroy
    @user.o_auths.find(params[:id]).destroy
  end

  def refresh
    o_auth = @user.o_auths.find(params[:o_auth_id])
    o_auth.refresh_token!
    render json: o_auth
  end

  def activate
    o_auth = @user.o_auths.find(params[:id])
    o_auth.activate!
    render json: o_auth
  end

  private

  def check_authorization!
    if current_user && params[:user_id] == current_user[:id].to_s
      true
    elsif RxModule::Authorization.current_user_can?(User.name, "read")
      true
    else
      Rails.logger.warn { {msg: "Unauthorized access attempted", authorization: applicable_authorization, user: RxModule::Authorization.current_user} }
      render json: {error: "User does not have the right to perform this action"}, status: :forbidden
    end
  end

  def set_user
    @user = if params[:user_id]
      User.find(params[:user_id])
    else
      OAuth.find(params[:id]).user
    end
  end
end
