# frozen_string_literal: true

class InvalidateEndpointCachesJob < ApplicationJob
  queue_as :default

  def perform
    RxModuleComponent.where(reachable: true).find_each do |component|
      RxModule::Communicator.call_module_method_as_module(component.module_id, "/api/rx_module/invalidate_endpoint_cache", :put)
    rescue => e
      Rails.logger.warn("Tried invalidating endpoint cache for module #{component.module_id}, but received an error")
      Rails.logger.warn(e)
    end
  end
end
